/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
// フレームワーク用サーブレット
// 
//
//	変更履歴
//	2004/01/08 新規作成	T.Nishiki
//
package jp.co.ntt.lms.xms.framework;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import jp.co.ntt.lms.xmo.util.DebugLog;

/**
 * フレームワーク共通サーブレット。<br>
 * @author nishiki
 */
public class FrameworkServlet extends HttpServlet {

	/**
	 * GET形式リクエスト処理メソッド。<br>
	 * @param request HTTPリクエスト。
	 * @param response HTTPレスポンス。
	 */
	protected void doGet(
		HttpServletRequest request,
		HttpServletResponse response)
		throws ServletException, IOException {

		// POSTと共通リクエスト処理メソッドを呼ぶ。
		this.doRequest(request, response);
	}

	/**
	 * POST形式リクエスト処理メソッド。<br>
	 * @param request HTTPリクエスト。
	 * @param response HTTPレスポンス。
	 */
	protected void doPost(
		HttpServletRequest request,
		HttpServletResponse response)
		throws ServletException, IOException {

		// GETと共通リクエスト処理メソッドを呼ぶ。
		this.doRequest(request, response);
	}

	/**
	 * リクエスト処理メソッド。<br>
	 * GET/POST共通で呼び出される。
	 * ＣＳＶダウンロードを要求された場合、あらかじめ保存したファイルを取得し、
	 * ダウンロードを試みる。<br>ファイルの取得に失敗した場合、
	 * ＣＳＶダウンロードの要求ではない場合、データ取得を実行する。
	 * @param request HTTPリクエスト。
	 * @param response HTTPレスポンス。
	 */
	protected void doRequest(
		HttpServletRequest request,
		HttpServletResponse response) {

		DebugLog.write(this.getClass(), "HEAD doRequest()", DebugLog.ROW);

		// フレームワーク戻り値。
		XmsResponse xmsResponse = null;
		// フレームワーク戻り値。
		XmsRequest xmsRequest = null;

		XmsBusinessControl businessControl = null;
		XmsScreenControl   screenControl   = null;
		
		businessControl = new XmsBusinessControl();
		screenControl   = new XmsScreenControl();
		try {
			// リクエスト・レスポンスオブジェクトの生成
			xmsRequest = new XmsRequest(request, response);
			xmsResponse = new XmsResponse();
			////////////////////////////////////////////////////////////////////
			// 更新業務振分処理
			businessControl.processRequest(xmsRequest, xmsResponse);
			////////////////////////////////////////////////////////////////////
			// 画面振分処理
			screenControl.processRequest(xmsRequest, xmsResponse);

			// 以降エラー処理
			// 各メソッド内でthrowableをキャッチしているので、
			// 各catchブロック内でtryブロックを記述していない。
		} catch (XmsWarningException e) {
			// XmsWarningException
			DebugLog.write(this.getClass(), e, DebugLog.HIGHT);
			screenControl.terminateWithWarningException(
				xmsRequest,
				xmsResponse,
				e);
		} catch (XmsInnerException e) {
			// XmsInnerException
			DebugLog.write(this.getClass(), e, DebugLog.HIGHT);
			screenControl.terminateWithInnerException(
				xmsRequest,
				xmsResponse,
				e);
		} catch (XmsSystemException e) {
			// XmsSystemException
			DebugLog.write(this.getClass(), e, DebugLog.HIGHT);
			screenControl.terminateWithSystemException(
				xmsRequest,
				xmsResponse,
				e);
		} catch (Throwable th) {
			// そのほか例外／エラー発生時
			DebugLog.write(this.getClass(), th, DebugLog.HIGHT);
			screenControl.terminateWithThrowable(
				xmsRequest,
				xmsResponse,
				th);
		} finally {
			DebugLog.write(this.getClass(), "TAIL doRequest()", DebugLog.ROW);
		}
	}
}
